-- See the Copyright notice at the end of this file.
--
class INTERNALS_HANDLER
	-- WARNING: This interface is tentative and may change to a large
	-- extent from SmartEiffel 2.2 to SmartEiffel 2.3.
	--
	-- All classes that use INTERNALS must be descendants of
	-- INTERNALS_HANDLER.

feature {}
	valid_generating_type_for_internals (type: STRING): BOOLEAN is
		require
			type /= Void
		external "built_in"
		ensure
			Result implies not type.has_prefix(once "NATIVE_ARRAY")
		end

	internals_from_generating_type (type: STRING): INTERNALS is
		require
			valid_generating_type_for_internals(type)
		external "built_in"
		ensure
			Result /= Void
			Result.object_can_be_modified
		end

	valid_generating_type_for_native_array_internals (type: STRING): BOOLEAN is
		require
			type /= Void
		external "built_in"
		ensure
			Result implies type.has_prefix(once "NATIVE_ARRAY")
		end

	native_array_internals_from_generating_type (type: STRING; capacity: INTEGER): INTERNALS is
		require
			valid_generating_type_for_native_array_internals(type)
		external "built_in"
		ensure
			Result /= Void
			Result.object_can_be_modified
		end

end -- class INTERNALS_HANDLER
--
-- ------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is part of the SmartEiffel standard library.
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
-- documentation files (the "Software"), to deal in the Software without restriction, including without
-- limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
-- the Software, and to permit persons to whom the Software is furnished to do so, subject to the following
-- conditions:
--
-- The above copyright notice and this permission notice shall be included in all copies or substantial
-- portions of the Software.
--
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO
-- EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
-- AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
-- OR OTHER DEALINGS IN THE SOFTWARE.
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------
