-- See the Copyright notice at the end of this file.
--
class DOUBLE_HASHED_DICTIONARY[V -> HASHABLE, K -> HASHABLE]
obsolete once "The new name for this class is now HASHED_BIJECTIVE_DICTIONARY (Feb 10th 2005)."

inherit
	DOUBLE_DICTIONARY[V, K]
		redefine right, reverse, copy
		end

creation {ANY}
	make, with_capacity

feature {ANY}
	copy (other: like Current) is
		do
			if right = Void then
				right := other.right.twin
			else
				right.copy(other.right)
			end
			if reverse = Void then
				reverse := other.reverse.twin
			else
				reverse.copy(other.reverse)
			end
		end

feature {DOUBLE_HASHED_DICTIONARY}
	right: HASHED_DICTIONARY[V, K]

	reverse: HASHED_DICTIONARY[K, V]

feature {}
	make is
		do
			create right.make
			create reverse.make
		end

	with_capacity (medium_size: INTEGER) is
		do
			create right.with_capacity(medium_size)
			create reverse.with_capacity(medium_size)
		end

end -- class DOUBLE_HASHED_DICTIONARY
--
-- ------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is part of the SmartEiffel standard library.
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
-- documentation files (the "Software"), to deal in the Software without restriction, including without
-- limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
-- the Software, and to permit persons to whom the Software is furnished to do so, subject to the following
-- conditions:
--
-- The above copyright notice and this permission notice shall be included in all copies or substantial
-- portions of the Software.
--
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO
-- EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
-- AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
-- OR OTHER DEALINGS IN THE SOFTWARE.
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------
