class RAW_CREATE_INSTRUCTION

inherit
	CREATE_INSTRUCTION
		rename
			make as create_instruction_make
		redefine
			cpp_expanded_attributes, compile_to_c
		end

creation
	make

feature {ANY}
	compile_to_c (type: TYPE) is
		local
			created_type_memory: TYPE
		do
			created_type_memory := created_type(type)
			if created_type_memory.is_reference then
				c2c_opening(type, created_type_memory)
				c2c_closing(type, created_type_memory)
			else
				writable.compile_to_c(type)
				cpp.put_string(once "=M")
				cpp.put_integer(created_type_memory.live_type.id)
				cpp.put_string(once ";%N")
			end
		end

feature {}
	cpp_expanded_attributes (type: TYPE; t: TYPE_MARK) is
		do
		end

	make (sp: like start_position; et: like explicit_type; w: like writable) is
		require
			not sp.is_unknown
			w /= Void
		do
			create_instruction_make(sp, et, w, Void)
		ensure
			start_position = sp
			explicit_type = et
			writable /= Void
			call = Void
		end

end -- class RAW_CREATE_INSTRUCTION
