-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class THREAD_TYPE_MARK

inherit
	SEPARATE_TYPE_MARK

creation {SEPARATE_TOOLS}
	make

creation {THREAD_TYPE_MARK}
	from_other

feature {ANY}
	specialize_in (new_type: TYPE): like Current is
		do
			Result := Current --|*** Actually all SCOOP must be rebuild *** (Dom april 15th 2004) ***
		end

	specialize_thru (parent_type: TYPE; inherit_item: INHERIT_TEXT_ITEM; new_type: TYPE): like Current is
		do
			Result := Current --|*** Actually all SCOOP must be rebuild *** (Dom april 15th 2004) ***
		end

	has_been_specialized: BOOLEAN is
		do
			Result := True --|*** Actually all SCOOP must be rebuild *** (Dom april 15th 2004) ***
		end

	accept (visitor: THREAD_TYPE_MARK_VISITOR) is
		do
			visitor.visit_thread_type_mark(Current)
		end

	c_header_pass1 is
		do
			standard_c_typedef
		end

	c_header_pass2 is
		do
		end

	c_header_pass3 is
		do
			if run_type = Current then
				thread_c_struct
			else
				run_type.c_header_pass3
			end
			thread_c_object_model
		end

	c_header_pass4 is
		do
			standard_c_print_function
		end

	c_type_for_argument_in (str: STRING) is
		do
			str.append(fz_t0_star)
		end

	c_type_for_target_in (str: STRING) is
		do
			str.extend('T')
			id.append_in(str)
			str.extend('*')
		end

	c_type_for_result_in (str: STRING) is
		do
			str.append(fz_t0_star)
		end

	need_c_struct: BOOLEAN is True

	c_sizeof: INTEGER is
		do
			Result := (1).object_size + 2 * default_pointer.object_size
		end

	c_initialize_in (buffer: STRING) is
		do
			buffer.append(fz_null)
		end

	need_gc_mark_function: BOOLEAN is True

feature {LIVE_TYPE, TYPE_MARK}
	just_before_gc_mark_in (str: STRING) is
		do
			standard_just_before_gc_mark_in(str)
		end

	gc_info_in (str: STRING) is
		do
			standard_gc_info_in(str)
		end

	gc_define1 is
		do
			standard_gc_define1
		end

	gc_define2 is
		do
			standard_gc_define2
		end

feature {}
	copy_from_other (other: like Current; m: like mapped): like Current is
		do
			create Result.from_other(other, m)
		end

	thread_c_struct is
			-- Modified version of `standard_c_struct'
		require
			run_type = Current
			need_c_struct
			cpp.on_h
		local
			wa: ARRAY[RUN_FEATURE_2]; mem_id: INTEGER; buffer: STRING
		do
			buffer := once "........................................."
			mem_id := id
			wa := live_type.writable_attributes
			buffer.copy(once "struct S")
			mem_id.append_in(buffer)
			buffer.extend('{')
			if live_type.is_tagged then
				buffer.append(once "Tid id;")
			end
			buffer.append(once "se_subsystem_t* subsystem;")
			mapped.c_type_for_target_in(buffer)
			buffer.append(once " ref;};%N")
			cpp.put_string(buffer)
		ensure
			cpp.on_h
		end

	frozen thread_c_object_model is
			-- Modified version of `standard_c_object_model'
		require
			run_type = Current
			cpp.on_h
		local
			mem_id: INTEGER; rc: LIVE_TYPE; buffer: STRING
		do
			buffer := once "........................................."
			rc := live_type
			mem_id := rc.id
			buffer.clear_count
			buffer.extend('T')
			mem_id.append_in(buffer)
			buffer.extend(' ')
			buffer.extend('M')
			mem_id.append_in(buffer)
			cpp.put_extern7(buffer)
			cpp.swap_on_c
			buffer.clear_count
			buffer.extend('{')
			id.append_in(buffer)
			buffer.append(once ",NULL,NULL};%N")
			cpp.put_string(buffer)
			cpp.swap_on_h
		ensure
			cpp.on_h
		end

end -- class THREAD_TYPE_MARK
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
