class PAPOOSE
--
-- PAPOOSE is not
-- Apache,
-- PAPOOSE is
-- Object
-- Oriented, written for
-- Smart
-- Eiffel
--
-- Well... PAPOOSE is just a very, very small HTTP server :-)
--
create {ANY}
	make

feature {ANY}
	make is
		local
			host: HOST
			tcp: TCP_ACCESS
			server: HTTP_SERVER
		do
			create host.make("localhost")
			create tcp.make(host, 8080)
			create server.stand_alone(tcp, agent error_handler, agent new_connection)
		end

	error_handler (text:STRING) is
		do
			std_output.put_string("error: ")
			std_output.put_string(text)
			std_output.put_string("%N")
		end

	new_connection: HTTP_CONNECTION is
		do
			create Result.make(method_handler_factory)
		end

	method_handler_factory: FUNCTION[TUPLE[STRING, STRING, STRING, OUTPUT_STREAM], HTTP_METHOD_HANDLER] is
		once
			Result := agent new_method_handler
		end

	new_method_handler (a_method, a_uri, a_version: STRING; a_out: OUTPUT_STREAM): HTTP_METHOD_HANDLER is
		do
			inspect a_method
			when "GET" then
				create {HTTP_GET_HANDLER} Result.make(a_uri, a_version, a_out)
			else
			end
		end
end
